## onnx 1.17.0

=== requirements.txt ===
numpy>=1.20
protobuf>=3.20.2
