=== docs/docsgen/source/requirements.txt ===

furo
markupsafe
matplotlib
myst-parser[linkify]
onnx
onnxruntime
pillow
pydot
sphinx-copybutton
sphinx-exec-code
sphinx-gallery
sphinx-tabs
sphinx
