=== debian/changelog ===
onnx (1.17.0-3build2) resolute; urgency=medium

  * No-change rebuild with Python 3.14 as supported version

 -- Graham Inggs <ginggs@ubuntu.com>  Mon, 20 Oct 2025 14:18:17 +0000

onnx (1.17.0-3build1) plucky; urgency=medium

  * No-change rebuild with Python 3.13 only

 -- Graham Inggs <ginggs@ubuntu.com>  Tue, 04 Mar 2025 17:42:48 +0000

onnx (1.17.0-3) unstable; urgency=medium

  * Autopkgtest: mask problematic tests for armel, riscv64, s390x.
  * Apply wrap-and-sort.
  * Copyright: bump year.
  * d/control: Fix capitalization error in description.
  * d/control: update package Section based on lintian I.
  * d/copyright: fix spelling error.
  * Bump Standards-Version to 4.7.0. No change needed.

 -- Mo Zhou <lumin@debian.org>  Thu, 30 Jan 2025 12:26:22 -0500

onnx (1.17.0-2) unstable; urgency=medium

  * Upload to unstable. (Closes: #1075852) (Fixes: CVE-2024-5187)
    The CVE was already fixed in the 1.16.2 release. I forgot to
    close the bug back then.

 -- Mo Zhou <lumin@debian.org>  Thu, 23 Jan 2025 11:21:11 -0500

onnx (1.17.0-1) experimental; urgency=medium

  * New upstream version 1.17.0
    Please pin to this version for PyTorch/v2.6.X release.
  * quilt: Refresh existing patches.
  * Autopkgtest: add the missing dependency python3-pi.
  * Patch code to avoid dependency on re2.
  * Autopkgtest: gate migration with CI results.
  * Upload to experimental.

 -- Mo Zhou <lumin@debian.org>  Mon, 20 Jan 2025 18:24:12 +0000
