=== requirements.txt ===
numpy>=1.22
protobuf>=4.25.1
typing_extensions>=4.7.1
ml_dtypes>=0.5.0
