=== docs/docsgen/source/requirements.txt ===
--- 
+++ 
@@ -4,7 +4,8 @@
 matplotlib
 myst-parser[linkify]
 onnx
-onnxruntime
+onnxruntime<1.20;python_version<"3.13"
+onnxruntime;python_version>="3.13"
 pillow
 pydot
 sphinx-copybutton
