=== debian/changelog ===
onnx (1.19.1-1~exp1) experimental; urgency=medium

  * Team upload.
  * New upstream version 1.19.1 (for PyTorch 2.9.x).
  * d/watch: switch to version 5.
  * d/patches: remove applied & expired patches.
  * d/control: bump std-ver to 4.7.2 (no changes required)
  * d/copyright: remove unused pattern.
  * d/lintian-overrides: remove unused rules.
  * d/py3dist-overrides: add python3-ml-dtypes.

 -- Shengqi Chen <harry@debian.org>  Thu, 23 Oct 2025 19:56:09 +0800
