=== debian/control ===
--- 
+++ 
@@ -2,7 +2,7 @@
 Section: science
 Homepage: https://onnx.ai
 Priority: optional
-Standards-Version: 4.7.0
+Standards-Version: 4.7.2
 Vcs-Git: https://salsa.debian.org/deeplearning-team/onnx.git
 Vcs-Browser: https://salsa.debian.org/deeplearning-team/onnx
 Maintainer: Debian Deep Learning Team <debian-ai@lists.debian.org>
