=== debian/watch ===
Version: 5
Template: GitHub
Owner: onnx
Project: onnx
RepackSuffix: +dfsg
