=== debian/changelog ===
onnx (1.20.0-1) unstable; urgency=medium

  * Team upload.
  * Upload to unstable.

 -- Shengqi Chen <harry@debian.org>  Mon, 12 Jan 2026 22:50:45 +0800

onnx (1.20.0-1~exp1) experimental; urgency=medium

  * Team upload.
  * New upstream version 1.20.0.
  * d/patches: refresh existing patches.
  * d/control: bump std-ver to 4.7.3 (no changes), remove useless fields.
  * d/control: replace pybind11 with nanobind in B-D.
  * d/patches: do not hide symbols in onnx_object (required by onnxruntime).

 -- Shengqi Chen <harry@debian.org>  Fri, 09 Jan 2026 22:43:20 +0800
