=== debian/control ===
--- 
+++ 
@@ -1,8 +1,7 @@
 Source: onnx
 Section: science
 Homepage: https://onnx.ai
-Priority: optional
-Standards-Version: 4.7.2
+Standards-Version: 4.7.3
 Vcs-Git: https://salsa.debian.org/deeplearning-team/onnx.git
 Vcs-Browser: https://salsa.debian.org/deeplearning-team/onnx
 Maintainer: Debian Deep Learning Team <debian-ai@lists.debian.org>
@@ -14,16 +13,15 @@
                cmake,
                libprotobuf-dev,
                protobuf-compiler,
-               pybind11-dev,
+               nanobind-dev,
                python3-all,
                python3-all-dev,
                python3-numpy <!nocheck>,
                python3-protobuf <!nocheck>,
-               python3-pybind11,
+               python3-nanobind,
                python3-pytest <!nocheck>,
                python3-pytest-runner,
                python3-tabulate <!nocheck>
-Rules-Requires-Root: no
 
 Package: python3-onnx
 Architecture: any
